#include "GuiOptions.h"


GuiOptions::GuiOptions(const TGWindow *p, const TGWindow *main, UInt_t w, UInt_t h):
	TGTransientFrame(p, main, w, h)  {
		

	SetLayoutBroken(kTRUE);
	Connect("CloseWindow()", "GuiOptions", this, "CloseWindow()");

	// group fits dir

	grFitsDir = new TGVButtonGroup(this,"Fits directory");
	grFitsDir->MoveResize(5,5,w-10,50);
	AddFrame(grFitsDir);

	tltDirFits = new TGLabel(grFitsDir,"device->getDirFits()");
	tltDirFits->MoveResize(20,20,270);
	grFitsDir->AddFrame(tltDirFits);
	
	tbChangeDir = new TGTextButton(grFitsDir,"Change");
	tbChangeDir->Connect("Clicked()","GuiOptions",this,"changeDir()");
	tbChangeDir->MoveResize(w-90,15,74);
	grFitsDir->AddFrame(tbChangeDir);

	// group fits viewer program
	
	grFitsViewer = new TGVButtonGroup(this,"Fits viewer program");
	grFitsViewer->MoveResize(5,50,265,80);
	AddFrame(grFitsViewer);
	
	teViewer = new TGTextEntry(grFitsViewer);
	teViewer->SetText("device->getFitsViewer()");
	teViewer->SetMaxLength(35);
	teViewer->Connect("ReturnPressed()","GuiOptions",this,"setFitsViewer()");
	teViewer->MoveResize(20,20,225);
	grFitsViewer->AddFrame(teViewer);
	
	tbChangeView = new TGTextButton(grFitsViewer,"Change");
	tbChangeView->Connect("Clicked()","GuiOptions",this,"setFitsViewer()");
	tbChangeView->MoveResize(170,45,74);
	grFitsViewer->AddFrame(tbChangeView);
	
	// group grFitsCompression

	grFitsCompr = new TGVButtonGroup(this,"Fits compression");
	grFitsCompr->SetRadioButtonExclusive(kTRUE);
	grFitsCompr->MoveResize(275,50,120,80);
	AddFrame(grFitsCompr);

    trbUseCompr = new TGRadioButton(grFitsCompr, "ASAS");
    trbUseCompr->MoveResize(40,25);
    trbUseCompr->Connect("Clicked()","GuiOptions",this,"setASASCompr()");
	grFitsCompr->AddFrame(trbUseCompr);

    trbNoCompr = new TGRadioButton(grFitsCompr, "None");
    trbNoCompr->MoveResize(40,45);
    trbNoCompr->Connect("Clicked()","GuiOptions",this,"setNoCompr()");
	grFitsCompr->AddFrame(trbNoCompr);
	
	if (1) {
		trbUseCompr->SetState(kButtonDown);	
	}
	else {
		trbNoCompr->SetState(kButtonDown);	
		
	}
	
	// close

	tbClose = new TGTextButton(this,"Close");
	tbClose->Connect("Clicked()","GuiOptions",this,"CloseWindow()");
	tbClose->MoveResize(w-80,140,74);
	this->AddFrame(tbClose);
	
	// status bar

	statusBar = new TGStatusBar(this);	
	Int_t statusBarParts[1] = { 100 };
	statusBar->SetParts(statusBarParts,1);
	statusBar->MoveResize(0,h-20,w,20);
	AddFrame(statusBar);
	
	this->SetWMSizeHints(w,h,w,h,0,0);
	
	//------------
	MapSubwindows();
	Layout();
	SetWindowName("Options");
	MapWindow();	
	// dialog mode
    gClient->WaitFor(this);

}

GuiOptions::~GuiOptions() {
	printf("GuiOptions DESTRUCTOR\n");
	
	// group FitsDir
	delete tbChangeDir;
	delete tltDirFits;
	delete grFitsDir;

	// group grFitsViewer
	delete teViewer;
	delete tbChangeView;
	delete grFitsViewer;
	
	// group grFitsCompression
	delete grFitsCompr;
	delete trbUseCompr;
	delete trbNoCompr;

	// close
	delete tbClose;
	
	// status bar
	delete statusBar;

}

void GuiOptions::CloseWindow() {
	printf("GuiOptions: CloseWindow()\n");
	DeleteWindow();
}


void GuiOptions::changeDir() {
}

void GuiOptions::setFitsViewer() {
}

void GuiOptions::setNoCompr() {
}

void GuiOptions::setASASCompr() {
}
