#ifndef __TEST2K2KGUI__
#define __TEST2K2KGUI__

#include <TApplication.h> 
#include <TGClient.h>
#include <TGButton.h>
#include <TGLabel.h>
#include <TGNumberEntry.h>
#include <RQ_OBJECT.h>
#include <TGDockableFrame.h>
#include <TGMenu.h>
#include <TGButtonGroup.h>
#include <TGProgressBar.h>
#include <TGStatusBar.h>
#include <TSystem.h>
#include <TQObject.h>
//#include <TSystemDirectory.h>
#include <TGListTree.h>
#include <TGFileDialog.h>
#include "GuiOptions.h"

#include "TThread.h"

#include <pthread.h>

void *ThreadGetInformations(void*);

enum MenuItem {
	MENU_EXIT,
	MENU_OPTIONS,
	MENU_CCDTOOLKIT,
	MENU_TESTOPTIONS,
	MENU_RESETCAMERA,
	MENU_RUNFITSVIEWER,
	MENU_FIRMWARECYPRESS,
	MENU_FIRMWAREALTERA,
	MENU_ADVANCEDACTIONS,
	MENU_EXPERTACTIONS,
	MENU_EXECUTESCRIPT
};

class Test2k2Gui : public TGMainFrame {

RQ_OBJECT("Test2k2Gui")

private:
	friend class GuiScript;
	friend void *ThreadGetInformations(void*);

	// menu
	TGMenuBar          *fMenuBar;
	TGPopupMenu        *fMenuFile;
	TGLayoutHints      *fMenuBarLayout, *fMenuBarItemLayout;

	// group temperature
	TGVButtonGroup	*grTemp;
    	TGLabel			*tltCooling;
    	TGLabel			*tlttemp1;
	TGLabel			*tliCCDTemp;
    	TGLabel			*tlttemp2;
	TGLabel			*tliCaseTemp;
    	TGLabel			*tlttemp3;
	TGLabel			*tliAmbientTemp;	 
	TGNumberEntry	*tgnTemp;
	TGTextButton	*tbChangeTemp;
	
	// group cooling
	TGVButtonGroup		*grCooling;
    TGRadioButton   *trbCoolingOn, *trbCoolingOff;

	// group shutter
	TGVButtonGroup	*grShutter;
	TGRadioButton	*trbShutterOpened, *trbShutterClosed, *trbDarkImage;
	TGNumberEntry	*tgnShutter;
	TGTextButton	*tbChangeShutter;
	TGHorizontalFrame *frShutter;
	
	// group picture
	TGVButtonGroup	*grPicture;
	TGHorizontalFrame *frPic1;
	TGLabel			*tltPicture;
	TGNumberEntry	*tgnPicture;
	TGTextButton	*tbGetPicture;
	TGHProgressBar	*progBarPic;
	
	// status bar
	TGStatusBar *statusBar;
	
	void Test2k2Gui::createThread();
	static Test2k2Gui* mainWindow;

public:
    Test2k2Gui(const TGWindow *p, UInt_t w, UInt_t h);
    virtual ~Test2k2Gui();
	virtual void CloseWindow();
	virtual void HandleMenu(Int_t);

    void getInfo();
    void setTemperature();
    void setShutterTime();
    void setShutterOpened();
    void setShutterClosed();
	void setDarkImage();
    void setCoolingOn();
    void setCoolingOff();
    void takePictures();
    void myRedraw(); // *SIGNAL*
    void refreshInfo();
    void refreshInfo2(int val) ;
    void changeFirmwareCypress();
    void changeFirmwareAltera();
	static Test2k2Gui* getWindow();
	
	TThread *mTh;
	static void* Thread0(void * arg);
	void threadStart();
    
	ClassDef(Test2k2Gui,0)
   
};

#endif // __TEST2K2KGUI__
